<template>
    <div>
        <div class="box">
            <div class="box-header">
                <h1>Users</h1>
            </div>
            <table>
                <thead>
                    <th>Username</th>
                    <th>Email</th>
                    <th>Signup date</th>
                    <th></th>
                </thead>
                <tbody>
                    <tr v-for="user in users" v-bind:key="user.id">
                        <td>{{user.user.username}}</td>
                        <td>{{user.user.email}}</td>
                        <td>{{user.user.created_at}}</td>
                        <td>
                            <button 
                                v-if="user.user.locked_at === null"
                                v-on:click="lockUser(user.user.id)"
                            >
                                Lock
                            </button>
                            <button 
                                v-if="user.user.locked_at !== null"
                                v-on:click="unlockUser(user.user.id)"
                            >
                                Unlock
                            </button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <Paginate
            :pageCount="pageCount"
            :clickHandler="changePage"
            :prevText="'Previous'"
            :nextText="'Next'"
            :containerClass="'paginate'"
        >
        </Paginate>

    </div>
</template>

<script lang="ts">
    import { Vue } from 'vue-property-decorator'
    import Paginate from 'vuejs-paginate'

    let users = {}

    export default Vue.extend({
        data() {
            return {
                users,
                page: 1,
                pageCount: 0
            }
        },
        components: {
            Paginate
        },
        methods: {
            changePage: function (pageNo: number) {
                this.page = pageNo
                this.$store.dispatch('admin_users_index',
                    { params: { page: this.page } })
                    .then(users => {
                        this.users = users.data.users
                        this.pageCount = users.data.page_count
                    })
            },
            lockUser: function (user_id: number) {
                this.$store.dispatch('admin_users_lock', {params: {user_id: user_id}}).then(() => {
                    this.changePage(this.page)
                })
                
            },
            unlockUser: function (user_id: number) {
                this.$store.dispatch('admin_users_unlock', {params: {user_id: user_id}}).then(() => {
                    this.changePage(this.page)
                })
            }
        },
        created: function () {
            this.$store.dispatch('admin_users_index', { params: { page: this.page } })
                .then(users => {
                    this.users = users.data.users
                    this.pageCount = users.data.page_count
                })
        }
    })
</script>
